Index: trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 1218)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 1229)
@@ -25,4 +25,6 @@
    no          =       0   !  job number
    cexper      = "Agulhas" !  experience name 
+   cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
+   cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
    nrstdt      =       0   !  restart control = 0 nit000 is not compared to the restart file value
@@ -624,4 +626,6 @@
    nctls      =   0        !  control surface type in mixed-layer trends (0,1 or n<jpk)
    ucf        =   1.       !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
+   cn_trdrst_in  = "restart_mld"   ! suffix of ocean restart name (input)
+   cn_trdrst_out = "restart_mld"   ! suffix of ocean restart name (output)
    ln_trdmld_restart = .false.  !  restart for ML diagnostics
    ln_trdmld_instant = .false.  !  flag to diagnose trends of instantantaneous or mean ML T/S
Index: trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist_ice_lim2
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist_ice_lim2	(revision 1218)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist_ice_lim2	(revision 1229)
@@ -14,4 +14,6 @@
 &namicerun     !   Share parameters for dynamics/advection/thermo
 !-----------------------------------------------------------------------
+   cn_icerst_in  = "restart_ice_in"   !  suffix of ice restart name (input)
+   cn_icerst_out = "restart_ice"      !  suffix of ice restart name (output)
    ln_limdyn   = .true.    !  ice dynamics (T) or thermodynamics only (F)
    ln_limdmp   = .false.   !  restoring ice thickness and fraction leads (T) or not (F)
Index: trunk/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 1218)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 1229)
@@ -25,4 +25,6 @@
    no          =       0   !  job number
    cexper      =  "ORCA2"  !  experience name 
+   cn_ocerst_in  = "restart"   !  suffix of ocean restart name (input)
+   cn_ocerst_out = "restart"   !  suffix of ocean restart name (output)
    ln_rstart   = .false.   !  start from rest (F) or from a restart file (T)
    nrstdt      =       0   !  restart control = 0 nit000 is not compared to the restart file value
@@ -646,6 +648,8 @@
    nctls      =   0        !  control surface type in mixed-layer trends (0,1 or n<jpk)
    ucf        =   1.       !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
-   ln_trdmld_restart = .false.  !  restart for ML diagnostics
-   ln_trdmld_instant = .false.  !  flag to diagnose trends of instantantaneous or mean ML T/S
+   cn_trdrst_in  = "restart_mld"   ! suffix of ocean restart name (input)
+   cn_trdrst_out = "restart_mld"   ! suffix of ocean restart name (output)
+   ln_trdmld_restart = .false.     !  restart for ML diagnostics
+   ln_trdmld_instant = .false.     !  flag to diagnose trends of instantantaneous or mean ML T/S
 /
 !-----------------------------------------------------------------------
Index: trunk/CONFIG/ORCA2_LIM/EXP00/namelist_ice_lim2
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/namelist_ice_lim2	(revision 1218)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/namelist_ice_lim2	(revision 1229)
@@ -14,4 +14,6 @@
 &namicerun     !   Share parameters for dynamics/advection/thermo
 !-----------------------------------------------------------------------
+   cn_icerst_in  = "restart_ice_in"   !  suffix of ice restart name (input)
+   cn_icerst_out = "restart_ice"      !  suffix of ice restart name (output)
    ln_limdyn   = .true.    !  ice dynamics (T) or thermodynamics only (F)
    ln_limdmp   = .false.   !  restoring ice thickness and fraction leads (T) or not (F)
Index: trunk/CONFIG/ORCA2_LIM/EXP00/namelist_ice_lim3
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/namelist_ice_lim3	(revision 1218)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/namelist_ice_lim3	(revision 1229)
@@ -14,4 +14,6 @@
 &namicerun     !   Share parameters for dynamics/advection/thermo
 !-----------------------------------------------------------------------
+   cn_icerst_in  = "restart_ice_in"   !  suffix of ice restart name (input)
+   cn_icerst_out = "restart_ice"      !  suffix of ice restart name (output)
    ln_limdyn   = .true.    !  ice dynamics (T) or thermodynamics only (F)
    acrit       =  1.0e-02 , 1.0e-02  !  minimum fraction for leads in the Northern (Southern) Hemisphere