Index: trunk/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- trunk/NEMO/LIM_SRC_3/limrhg.F90	(revision 1243)
+++ trunk/NEMO/LIM_SRC_3/limrhg.F90	(revision 1244)
@@ -4,4 +4,8 @@
    !!   Ice rheology : sea ice rheology
    !!======================================================================
+   !! History :   -   !  2007-03  (M.A. Morales Maqueda, S. Bouillon) Original code
+   !!            3.0  !  2008-03  (M. Vancoppenolle) LIM3
+   !!             -   !  2008-11  (M. Vancoppenolle, S. Bouillon, Y. Aksenov) add surface tilt in ice rheolohy 
+   !!----------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
@@ -16,4 +20,5 @@
    USE dom_oce
    USE dom_ice
+   USE sbc_oce         ! Surface boundary condition: ocean fields
    USE sbc_ice         ! Surface boundary condition: ice fields
    USE ice
@@ -100,8 +105,4 @@
       !!                 Vancoppenolle et al., OM08
       !!
-      !! History :
-      !!   1.0  !  07-03  (M.A. Morales Maqueda, S. Bouillon)
-      !!   2.0  !  08-03  M. Vancoppenolle : LIM3
-      !!
       !!-------------------------------------------------------------------
       ! * Arguments
@@ -290,9 +291,7 @@
             ! SB On utilise maintenant le gradient de la pente de l'ocean
             ! include it later
-            !    zdsshx =  (ssh_io(ji+1,jj) - ssh_io(ji,jj))/e1u(ji,jj)
-            !    zdsshy =  (ssh_io(ji,jj+1) - ssh_io(ji,jj))/e2v(ji,jj)  
-
-            zdsshx = 0.0
-            zdsshy = 0.0 
+
+            zdsshx =  (ssh_m(ji+1,jj) - ssh_m(ji,jj))/e1u(ji,jj)
+            zdsshy =  (ssh_m(ji,jj+1) - ssh_m(ji,jj))/e2v(ji,jj)
 
             za1ct(ji,jj) = ztagnx - zmass1(ji,jj) * grav * zdsshx
Index: trunk/NEMO/OPA_SRC/SBC/sbc_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 1243)
+++ trunk/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 1244)
@@ -63,4 +63,5 @@
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sst_m     !: mean (nn_fsbc time-step) surface sea temperature     [Celsius]
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sss_m     !: mean (nn_fsbc time-step) surface sea salinity            [psu]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ssh_m     !: mean (nn_fsbc time-step) sea surface height                [m]
 
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 1243)
+++ trunk/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 1244)
@@ -64,4 +64,5 @@
          sst_m(:,:) = tn(:,:,1)
          sss_m(:,:) = sn(:,:,1)
+         ssh_m(:,:) = sshn(:,:)
          !
       ELSE
@@ -78,4 +79,5 @@
                CALL iom_get( numror, jpdom_autoglo, 'sst_m'  , sst_m  )   !   "         "    temperature (T-point)
                CALL iom_get( numror, jpdom_autoglo, 'sss_m'  , sss_m  )   !   "         "    salinity    (T-point)
+               CALL iom_get( numror, jpdom_autoglo, 'ssh_m'  , ssh_m  )   !   "         "    height      (T-point)
                !
                IF( zf_sbc /= REAL( nn_fsbc, wp ) ) THEN      ! nn_fsbc has changed between 2 runs
@@ -87,4 +89,5 @@
                   sst_m(:,:) = zcoef * sst_m(:,:)
                   sss_m(:,:) = zcoef * sss_m(:,:)
+                  ssh_m(:,:) = zcoef * ssh_m(:,:)
                ELSE
                   IF(lwp) WRITE(numout,*) '~~~~~~~   mean fields read in the ocean restart file'
@@ -97,4 +100,5 @@
                sst_m(:,:) = zcoef * tn(:,:,1)
                sss_m(:,:) = zcoef * sn(:,:,1)
+               ssh_m(:,:) = zcoef * sshn(:,:)
             ENDIF
             !                                             ! ---------------------------------------- !
@@ -105,4 +109,5 @@
             sst_m(:,:) = 0.e0
             sss_m(:,:) = 0.e0
+            ssh_m(:,:) = 0.e0
          ENDIF
          !                                                ! ---------------------------------------- !
@@ -113,4 +118,5 @@
          sst_m(:,:) = sst_m(:,:) + tn(:,:,1)
          sss_m(:,:) = sss_m(:,:) + sn(:,:,1)
+         ssh_m(:,:) = ssh_m(:,:) + sshn(:,:)
 
          !                                                ! ---------------------------------------- !
@@ -122,4 +128,5 @@
             ssu_m(:,:) = ssu_m(:,:) * zcoef           ! mean suface current  [m/s]
             ssv_m(:,:) = ssv_m(:,:) * zcoef           !
+            ssh_m(:,:) = ssh_m(:,:) * zcoef           ! mean SSH             [m]
             !
          ENDIF
@@ -137,4 +144,5 @@
             CALL iom_rstput( kt, nitrst, numrow, 'sst_m'  , sst_m  )
             CALL iom_rstput( kt, nitrst, numrow, 'sss_m'  , sss_m  )
+            CALL iom_rstput( kt, nitrst, numrow, 'ssh_m'  , ssh_m  )
             !
          ENDIF