Index: trunk/NEMO/TOP_SRC/TRP/trcbbc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trcbbc.F90	(revision 1257)
+++ trunk/NEMO/TOP_SRC/TRP/trcbbc.F90	(revision 1258)
@@ -161,5 +161,5 @@
       CHARACTER (len=32) ::   clname
       INTEGER  ::   ji, jj              ! dummy loop indices
-      INTEGER  ::   inum = 11           ! temporary logical unit
+      INTEGER  ::   inum                ! temporary logical unit
 
       NAMELIST/namtopbbc/ngeo_trc_flux, ngeo_trc_flux_const 
Index: trunk/NEMO/TOP_SRC/TRP/trczdf_iso.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trczdf_iso.F90	(revision 1257)
+++ trunk/NEMO/TOP_SRC/TRP/trczdf_iso.F90	(revision 1258)
@@ -128,5 +128,4 @@
       INTEGER ::   iku, ikv, ikv1             ! temporary integers
 
-      REAL(wp) ::   ztra
       REAL(wp) ::   &
          ztavg,                 &  ! ???
@@ -374,5 +373,5 @@
                      !     meridional, and vertical trends are valid.
 #       if defined key_diaeiv
-                     z_hdivn_z = ( 1./e3t(jk) ) * ( w_trc_eiv(ji,jj,jk) - w_trc_eiv(ji,jj,jk+1) )
+                     z_hdivn_z = ( 1. / fse3t(ji,jj,jk) ) * ( w_trc_eiv(ji,jj,jk) - w_trc_eiv(ji,jj,jk+1) )
 #       else
                      z_hdivn_z = 0.e0
@@ -453,6 +452,6 @@
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
-                  ztra = ( zwx(ji,jk) - trb(ji,jj,jk,jn) ) / rdttrc(jk)
-                  IF (luttrd(jn)) trtrd(ji,jj,jk,ikeep(jn),6) = ztra - tra(ji,jj,jk,jn) + trtrd(ji,jj,jk,ikeep(jn),6)
+                  ztav = ( zwx(ji,jk) - trb(ji,jj,jk,jn) ) / rdttrc(jk)
+                  IF (luttrd(jn)) trtrd(ji,jj,jk,ikeep(jn),6) = ztav - tra(ji,jj,jk,jn) + trtrd(ji,jj,jk,ikeep(jn),6)
                END DO
             END DO
@@ -460,6 +459,6 @@
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
-                  ztra = ( zwx(ji,jk) - trb(ji,jj,jk,jn) ) / rdttrc(jk)
-                  IF (luttrd(jn)) trtrd(ji,jj,jk,ikeep(jn),6) = ztra - tra(ji,jj,jk,jn)
+                  ztav = ( zwx(ji,jk) - trb(ji,jj,jk,jn) ) / rdttrc(jk)
+                  IF (luttrd(jn)) trtrd(ji,jj,jk,ikeep(jn),6) = ztav - tra(ji,jj,jk,jn)
                END DO
             END DO
Index: trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90	(revision 1257)
+++ trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90	(revision 1258)
@@ -158,6 +158,6 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
          zwi, zwt, zavsi                     ! temporary workspace arrays
-      REAL(wp) ::   ztra                     ! temporary scalars
 #  if defined key_trc_diatrd
+      REAL(wp) ::   ztra
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrd
 #  endif
@@ -595,5 +595,5 @@
                      !     meridional, and vertical trends are valid.
 #   if defined key_diaeiv
-                     z_hdivn_z = ( 1./e3t(jk) ) * ( w_trc_eiv(ji,jj,jk) - w_trc_eiv(ji,jj,jk+1) )
+                     z_hdivn_z = ( 1. / fse3t(ji,jj,jk) ) * ( w_trc_eiv(ji,jj,jk) - w_trc_eiv(ji,jj,jk+1) )
 #   else
                      z_hdivn_z = 0.e0
Index: trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1257)
+++ trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1258)
@@ -16,8 +16,8 @@
    !!   trd_mld_trc_init : initialization step
    !!----------------------------------------------------------------------
-   USE trp_trc               ! tracer definitions (trn, trb, tra, etc.)
+   USE trp_trc           ! tracer definitions (trn, trb, tra, etc.)
    USE oce_trc           ! needed for namelist logicals, and euphotic layer arrays
    USE trctrp_lec
-   USE trdmld_trc_oce        ! definition of main arrays used for trends computations
+   USE trdmld_trc_oce    ! definition of main arrays used for trends computations
    USE in_out_manager    ! I/O manager
    USE dianam            ! build the name of file (routine)
@@ -29,7 +29,5 @@
    USE sms_pisces        
    USE sms_lobster
-   USE trcsms_cfc
    USE trc
-   USE trcrst            ! for lrst_trc -> circ. dep. ??? we put lrst_trc in trc_oce
 
    IMPLICIT NONE
Index: trunk/NEMO/TOP_SRC/TRP/trdmld_trc_rst.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trdmld_trc_rst.F90	(revision 1257)
+++ trunk/NEMO/TOP_SRC/TRP/trdmld_trc_rst.F90	(revision 1258)
@@ -12,5 +12,4 @@
    USE in_out_manager  ! I/O manager
    USE iom             ! I/O module
-   USE trcrst          ! only for lrst_trc
    USE trc             ! for ndttrc ctrcnm
    USE trdmld_trc_oce  ! for lk_trdmld_trc
Index: trunk/NEMO/TOP_SRC/TRP/trp_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trp_trc.F90	(revision 1257)
+++ trunk/NEMO/TOP_SRC/TRP/trp_trc.F90	(revision 1258)
@@ -18,14 +18,18 @@
 
    !! passive tracers fields 
-   USE trc    , ONLY :   trai     =>   trai     !: initial total tracer
-   USE trc    , ONLY :   trb      =>   trb      !: tracer field (before)
-   USE trc    , ONLY :   tra      =>   tra      !: tracer field (now)
-   USE trc    , ONLY :   trn      =>   trn      !: tracer field (after)
+   USE trc, ONLY :   trai      =>   trai     !: initial total tracer
+   USE trc, ONLY :   trb       =>   trb      !: tracer field (before)
+   USE trc, ONLY :   tra       =>   tra      !: tracer field (now)
+   USE trc, ONLY :   trn       =>   trn      !: tracer field (after)
+
+   !! Ocean volume
+   USE trc, ONLY :   cvol      =>   cvol     !: masked grid volume
 
    !! time step
-   USE trc    , ONLY :   ndttrc   =>   ndttrc   !: frequency of step on passive tracers (NAMELIST)
-   USE trc    , ONLY :   ctrcnm   =>   ctrcnm   !: 
-   USE trc    , ONLY :   numnat   =>   numnat   !: namelist
-   USE trc    , ONLY :   nittrc000 =>  nittrc000
+   USE trc, ONLY :   ndttrc    =>   ndttrc   !: frequency of step on passive tracers (NAMELIST)
+   USE trc, ONLY :   ctrcnm    =>   ctrcnm   !: 
+   USE trc, ONLY :   numnat    =>   numnat   !: namelist
+   USE trc, ONLY :   nittrc000 =>   nittrc000
+   USE trc, ONLY :   lrst_trc  =>   lrst_trc  !: logical to control the trc restart write
 
    !! isopycnal scheme for passive tracers