Index: /trunk/NEMO/TOP_SRC/LOBSTER/trcbio.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 1264)
@@ -61,5 +61,5 @@
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
-      INTEGER  ::   ji, jj, jk, jn, jl
+      INTEGER  ::   ji, jj, jk, jl
       REAL(wp) ::   zdet, zzoo, zphy, zno3, znh4, zdom      ! now concentrations
       REAL(wp) ::   zlno3, zlnh4, zle, zlt                  ! limitation terms for phyto
Index: /trunk/NEMO/TOP_SRC/MY_TRC/trcctl_my_trc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/MY_TRC/trcctl_my_trc.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/MY_TRC/trcctl_my_trc.F90	(revision 1264)
@@ -61,3 +61,2 @@
    !!======================================================================
 END MODULE trcctl_my_trc
-      
Index: /trunk/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 1264)
@@ -82,16 +82,10 @@
           
       CALL p4z_sink ( kt, jnt )     ! vertical flux of particulate organic matter
-
       CALL p4z_opt  ( kt, jnt )     ! Optic: PAR in the water column
-
       CALL p4z_lim  ( kt, jnt )     ! co-limitations by the various nutrients
-
       CALL p4z_prod ( kt, jnt )     ! phytoplankton growth rate over the global ocean. 
       !                             ! (for each element : C, Si, Fe, Chl )
-
       CALL p4z_rem  ( kt, jnt )     ! remineralization terms of organic matter+scavenging of Fe
-
       CALL p4z_mort ( kt, jnt )     ! phytoplankton mortality
-
       !                             ! zooplankton sources/sinks routines 
       CALL p4z_micro( kt, jnt )           ! microzooplankton
Index: /trunk/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 1264)
@@ -32,4 +32,7 @@
      sinkfer                   !: Small BFe sinking flux
 
+   REAL(wp) ::   &
+     xstep , xstep2            !: Time step duration for biology
+
 #if  defined key_kriest
    REAL(wp)          ::       &   
@@ -92,5 +95,4 @@
       REAL(wp) :: zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
       REAL(wp) :: zval1, zval2, zval3, zval4
-      REAL(wp) :: zstep
 #if defined key_trc_dia3d
       REAL(wp) ::   zrfact2
@@ -101,8 +103,9 @@
       !!---------------------------------------------------------------------
 
-      IF( ( kt * jnt ) == nittrc000  )   CALL p4z_sink_init   ! Initialization (first time-step only)
-
-       zstep = rfact2 / rjjss      ! Time step duration for biology
-
+      IF( ( kt * jnt ) == nittrc000  )  THEN 
+          CALL p4z_sink_init   ! Initialization (first time-step only)
+          xstep  = rfact2 / rjjss      ! Time step duration for biology
+          xstep2 = rfact2 /  2.
+      ENDIF
 
 !     Initialisation of variables used to compute Sinking Speed
@@ -252,5 +255,5 @@
                      &    )
 
-                  zaggsi = ( zagg4 + zagg5 ) * zstep / 10.
+                  zaggsi = ( zagg4 + zagg5 ) * xstep / 10.
 
                   zagg = 0.5 * xkr_stick * ( zaggsh + zaggsi )
@@ -260,5 +263,5 @@
 
                   zaggdoc = ( 0.4 * trn(ji,jj,jk,jpdoc)               &
-                     &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * zstep    &
+                     &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * xstep    &
 # if defined key_off_degrad
                      &        * facvol(ji,jj,jk)                              &
@@ -450,5 +453,5 @@
       REAL(wp) ::   zagg1, zagg2, zagg3, zagg4
       REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2
-      REAL(wp) ::   zfact, zstep, zwsmax
+      REAL(wp) ::   zfact, zwsmax
 #if defined key_trc_dia3d
       REAL(wp) ::   zrfact2
@@ -457,6 +460,8 @@
       !!---------------------------------------------------------------------
 
-       zstep = rfact2 / rjjss      ! Timestep duration for biology
-
+      IF( ( kt * jnt ) == nittrc000  )  THEN
+          xstep  = rfact2 / rjjss      ! Timestep duration for biology
+          xstep2 = rfact2 /  2.
+      ENDIF
 
 !    Sinking speeds of detritus is increased with depth as shown
@@ -490,5 +495,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zwsmax = 0.8 * fse3t(ji,jj,jk) / zstep
+               zwsmax = 0.8 * fse3t(ji,jj,jk) / xstep
                wsbio4(ji,jj,jk) = MIN( wsbio4(ji,jj,jk), zwsmax )
                wsbio3(ji,jj,jk) = MIN( wsbio3(ji,jj,jk), zwsmax )
@@ -527,5 +532,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zfact = zstep * xdiss(ji,jj,jk)
+               zfact = xstep * xdiss(ji,jj,jk)
 
 !    Part I : Coagulation dependent on turbulence
@@ -549,13 +554,13 @@
 
 # if defined key_off_degrad
-               zagg3 = 0.66 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc) * facvol(ji,jj,jk)
+               zagg3 = 0.66 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc) * facvol(ji,jj,jk)
 # else
-               zagg3 = 0.66 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
-# endif
-
-# if defined key_off_degrad
-               zagg4 = 0.e0 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc) * facvol(ji,jj,jk)
+               zagg3 = 0.66 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
+# endif
+
+# if defined key_off_degrad
+               zagg4 = 0.e0 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc) * facvol(ji,jj,jk)
 # else
-               zagg4 = 0.e0 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
+               zagg4 = 0.e0 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
 # endif
 
@@ -627,10 +632,9 @@
       !!
       INTEGER  ::   ji, jj, jk, jn
-      REAL(wp) ::   zigma,zew,zstep,zign, zflx
+      REAL(wp) ::   zigma,zew,zign, zflx
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztraz, zakz
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zwsink2
       !!---------------------------------------------------------------------
 
-      zstep  = rfact2 / 2.
 
       ztraz(:,:,:) = 0.e0
@@ -680,7 +684,7 @@
             DO jj = 1, jpj      
                DO ji = 1, jpi    
-                  zigma = zwsink2(ji,jj,jk+1) * zstep / fse3w(ji,jj,jk+1)
+                  zigma = zwsink2(ji,jj,jk+1) * xstep2 / fse3w(ji,jj,jk+1)
                   zew   = zwsink2(ji,jj,jk+1)
-                  psinkflx(ji,jj,jk+1) = -zew * ( trn(ji,jj,jk,jp_tra) - 0.5 * ( 1 + zigma ) * zakz(ji,jj,jk) ) * zstep
+                  psinkflx(ji,jj,jk+1) = -zew * ( trn(ji,jj,jk,jp_tra) - 0.5 * ( 1 + zigma ) * zakz(ji,jj,jk) ) * xstep2
                END DO
             END DO
Index: /trunk/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 1264)
@@ -80,3 +80,2 @@
    !!======================================================================   
 END MODULE sms_pisces    
-
Index: /trunk/NEMO/TOP_SRC/PISCES/trcctl_pisces.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/PISCES/trcctl_pisces.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/PISCES/trcctl_pisces.F90	(revision 1264)
@@ -68,3 +68,2 @@
    !!======================================================================
 END MODULE trcctl_pisces
-      
Index: /trunk/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 1264)
@@ -54,5 +54,5 @@
       !! ** Purpose :   Initialisation of the PISCES biochemical model
       !!----------------------------------------------------------------------
-      INTEGER ::   ji, jj, jk, jn
+      INTEGER ::   ji, jj, jk
       REAL(wp) ::  caralk, bicarb, co3
 
Index: /trunk/NEMO/TOP_SRC/SED/sedadv.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/sedadv.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/sedadv.F90	(revision 1264)
@@ -457,3 +457,2 @@
 #endif
 END MODULE sedadv
-                  
Index: /trunk/NEMO/TOP_SRC/SED/sedco3.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/sedco3.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/sedco3.F90	(revision 1264)
@@ -211,3 +211,2 @@
 
 END MODULE sedco3
-
Index: /trunk/NEMO/TOP_SRC/SED/seddta.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/seddta.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/seddta.F90	(revision 1264)
@@ -275,4 +275,5 @@
    SUBROUTINE sed_dta ( kt )
      INTEGER, INTENT(in) :: kt
+     WRITE(*,*) 'sed_stp: You should not have seen this print! error?', kt 
   END SUBROUTINE sed_dta
 #endif
Index: /trunk/NEMO/TOP_SRC/SED/sedini.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/sedini.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/sedini.F90	(revision 1264)
@@ -861,5 +861,2 @@
 
 END MODULE sedini
-
-
-
Index: /trunk/NEMO/TOP_SRC/SED/sedmbc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/sedmbc.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/sedmbc.F90	(revision 1264)
@@ -334,7 +334,2 @@
 #endif
 END MODULE sedmbc
-
-
-
-
-
Index: /trunk/NEMO/TOP_SRC/SED/sedmodel.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/sedmodel.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/sedmodel.F90	(revision 1264)
@@ -50,5 +50,5 @@
 #else
    !!======================================================================
-   !! MODULE sedbtb  :   Dummy module 
+   !! MODULE sedmodel  :   Dummy module 
    !!======================================================================
 CONTAINS
@@ -60,9 +60,2 @@
 
 END MODULE sedmodel
-
-
-
-
-
-
-
Index: /trunk/NEMO/TOP_SRC/SED/sedstp.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/SED/sedstp.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/SED/sedstp.F90	(revision 1264)
@@ -58,5 +58,5 @@
       CALL sed_sfc( kt )         ! Give back new bottom wat chem to tracer model
 #endif
-      CALL sed_rst_write( kt )   ! restart file output
+      CALL sed_rst_wri( kt )   ! restart file output
       CALL sed_wri( kt )         ! outputs
 
@@ -75,11 +75,3 @@
    END SUBROUTINE sed_stp
 #endif
-
 END MODULE sedstp
-
-
-
-
-
-
-
Index: /trunk/NEMO/TOP_SRC/TRP/trcadv_muscl.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcadv_muscl.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcadv_muscl.F90	(revision 1264)
@@ -80,6 +80,9 @@
       REAL(wp) ::   z0u, z0v, z0w
       REAL(wp) ::   zzt1, zzt2, zalpha, z2dtt
-      REAL(wp) ::   ztai, ztaj, zfui, zfvj
+      REAL(wp) ::   zfui, zfvj
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
+#if defined key_trc_diatrd
+      REAL(wp) ::   ztai, ztaj
+#endif
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
Index: /trunk/NEMO/TOP_SRC/TRP/trcadv_muscl2.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcadv_muscl2.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcadv_muscl2.F90	(revision 1264)
@@ -82,8 +82,9 @@
       REAL(wp) ::   z0u, z0v, z0w
       REAL(wp) ::   zzt1, zzt2, zalpha
-
-      REAL(wp) ::   ztai, ztaj
       REAL(wp) ::   zfui, zfvj
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
+#if defined key_trc_diatrd
+      REAL(wp) ::   ztai, ztaj
+#endif
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
Index: /trunk/NEMO/TOP_SRC/TRP/trcadv_tvd.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcadv_tvd.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcadv_tvd.F90	(revision 1264)
@@ -77,5 +77,7 @@
       REAL(wp) ::   zfp_ui, zfp_vj, zfp_wk
       REAL(wp) ::   zfm_ui, zfm_vj, zfm_wk
+#if defined key_trc_diatrd
       REAL(wp) ::   zgm, zgz
+#endif
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
Index: /trunk/NEMO/TOP_SRC/TRP/trcbbl.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 1264)
@@ -107,8 +107,11 @@
       INTEGER ::   ii0, ii1, ij0, ij1                       ! temporary integers
       INTEGER ::   iku1, iku2, ikv1, ikv2                   ! temporary intergers
-      REAL(wp) ::   ze3u, ze3v                              ! temporary scalars
-      REAL(wp) ::   zsign, zt, zs, zh, zalbet
-      REAL(wp) ::   zgdrho, zbtr, ztra
-      REAL(wp), DIMENSION(jpi,jpj) ::   zki, zkj, zkx, zky  ! temporary workspace arrays
+      REAL(wp) ::  ze3u, ze3v                              ! temporary scalars
+      REAL(wp) ::  zbtr, ztra
+#if ! defined key_off_tra
+      REAL(wp) ::   zgdrho, zalbet, zsign, zt, zs, zh
+      REAL(wp), DIMENSION(jpi,jpj) ::   zki, zkj
+#endif
+      REAL(wp), DIMENSION(jpi,jpj) ::   zkx, zky  ! temporary workspace arrays
       REAL(wp), DIMENSION(jpi,jpj) ::   ztnb, zsnb, zdep
       REAL(wp), DIMENSION(jpi,jpj) ::   ztrb, zahu, zahv
Index: /trunk/NEMO/TOP_SRC/TRP/trcldf_bilapg.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcldf_bilapg.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcldf_bilapg.F90	(revision 1264)
@@ -65,5 +65,4 @@
       INTEGER, INTENT( in ) ::   kt                         ! ocean time-step index
       INTEGER ::   ji, jj, jk, jn                           ! dummy loop indices
-      REAL(wp) ::   ztra                                    ! workspace   
       REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   wk1, wk2  ! work array used for rotated biharmonic
       !                                                     ! operator on tracers and/or momentum
Index: /trunk/NEMO/TOP_SRC/TRP/trcldf_iso_zps.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcldf_iso_zps.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcldf_iso_zps.F90	(revision 1264)
@@ -320,5 +320,4 @@
 
          ENDIF
-!CDIR END
          !                                                       ! ===========
       END DO                                                     ! tracer loop
Index: /trunk/NEMO/TOP_SRC/TRP/trcldf_lap.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trcldf_lap.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trcldf_lap.F90	(revision 1264)
@@ -78,5 +78,5 @@
 
       REAL(wp) ::   &
-         ztra, ztrax, ztray               ! workspace
+         ztrax, ztray               ! workspace
       CHARACTER (len=22) :: charout
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
Index: /trunk/NEMO/TOP_SRC/TRP/trczdf_imp.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trczdf_imp.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trczdf_imp.F90	(revision 1264)
@@ -85,5 +85,7 @@
          zwd, zws, zwi,          &  ! ???
          zwx, zwy, zwt              ! ???
+#if defined key_trc_diatrd
       REAL(wp) ::  ztra      ! temporary scalars
+#endif
       REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   &
          ztrd
Index: /trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trczdf_iso_vopt.F90	(revision 1264)
@@ -85,5 +85,5 @@
       ! -----------------------------------------------------
 
-      CALL trc_zdf_iso( kt )
+      CALL trc_zdf_iso
 
       IF( ln_ctl ) THEN    ! print mean trends (used for debugging)
@@ -369,5 +369,5 @@
 
 
-   SUBROUTINE trc_zdf_iso( kt )
+   SUBROUTINE trc_zdf_iso
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trc_zdf_iso  ***
@@ -411,5 +411,4 @@
                             zwy => va      ! workspace arrays
 
-      INTEGER, INTENT( in ) ::   kt              ! ocean time-step index
       INTEGER ::   ji, jj, jk, jn                ! dummy loop indices
       INTEGER ::   iku, ikv                      
Index: /trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1263)
+++ /trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1264)
@@ -1598,4 +1598,5 @@
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', ctype
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', ktrd
+      WRITE(*,*) '  "      "      : You should not have seen this print! error?', kjn
    END SUBROUTINE trd_mld_trc_zint
 