Index: /trunk/NEMO/OPA_SRC/SBC/sbcblk_clio.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 1269)
+++ /trunk/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 1270)
@@ -30,9 +30,7 @@
    USE prtctl          ! Print control
 #if defined key_lim3
-   USE par_ice
    USE ice
    USE ice_oce         ! For ice surface temperature
 #elif defined key_lim2
-   USE par_ice_2
    USE ice_2
 #endif
@@ -414,5 +412,5 @@
       &                      p_qla , p_dqns, p_dqla,          &
       &                      p_tpr , p_spr ,                  &
-      &                      p_fr1 , p_fr2 , cd_grid  )
+      &                      p_fr1 , p_fr2 , cd_grid, pdim  )
       !!---------------------------------------------------------------------------
       !!                     ***  ROUTINE blk_ice_clio  ***
@@ -452,4 +450,5 @@
       REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   p_fr2    ! 2nd fraction of qsr penetration in ice         [%]
       CHARACTER(len=1), INTENT(in   )             ::   cd_grid  ! type of sea-ice grid ("C" or "B" grid)
+      INTEGER, INTENT(in   )                      ::   pdim     ! number of ice categories
       !!
       INTEGER  ::   ji, jj, jl    ! dummy loop indices
@@ -467,8 +466,8 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   zevsqr  ! vapour pressure square-root
       REAL(wp), DIMENSION(jpi,jpj) ::   zrhoa   ! air density
-      REAL(wp), DIMENSION(jpi,jpj,SIZE(pst,3)) ::   z_qlw, z_qsb
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qlw, z_qsb
       !!---------------------------------------------------------------------
 
-      ijpl  = SIZE( pst, 3 )                 ! number of ice categories
+      ijpl  = pdim                           ! number of ice categories
       zpatm = 101000.                        ! atmospheric pressure  (assumed constant  here)
 
Index: /trunk/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 1269)
+++ /trunk/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 1270)
@@ -31,9 +31,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
-#if defined key_lim2
-   USE par_ice_2       ! For number of ice categories
-#endif
 #if defined key_lim3
-   USE par_ice         ! For number of ice categories
    USE ice_oce         ! For ice surface temperature
 #endif
@@ -342,5 +338,5 @@
       &                      p_qla , p_dqns, p_dqla,          &
       &                      p_tpr , p_spr ,                  &
-      &                      p_fr1 , p_fr2 , cd_grid  ) 
+      &                      p_fr1 , p_fr2 , cd_grid, pdim  ) 
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE blk_ice_core  ***
@@ -355,20 +351,21 @@
       !! caution : the net upward water flux has with mm/day unit
       !!---------------------------------------------------------------------
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpl)  ::   pst      ! ice surface temperature (>0, =rt0 over land) [Kelvin]
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj)      ::   pui      ! ice surface velocity (i- and i- components      [m/s]
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj)      ::   pvi      !    at I-point (B-grid) or U & V-point (C-grid)
-      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpl)  ::   palb     ! ice albedo (clear sky) (alb_ice_cs)               [%]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)      ::   p_taui   ! i- & j-components of surface ice stress        [N/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)      ::   p_tauj   !   at I-point (B-grid) or U & V-point (C-grid)
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj,jpl)  ::   p_qns    ! non solar heat flux over ice (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj,jpl)  ::   p_qsr    !     solar heat flux over ice (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj,jpl)  ::   p_qla    ! latent    heat flux over ice (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj,jpl)  ::   p_dqns   ! non solar heat sensistivity  (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj,jpl)  ::   p_dqla   ! latent    heat sensistivity  (T-point)         [W/m2]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)      ::   p_tpr    ! total precipitation          (T-point)      [Kg/m2/s]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)      ::   p_spr    ! solid precipitation          (T-point)      [Kg/m2/s]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)      ::   p_fr1    ! 1sr fraction of qsr penetration in ice (T-point)  [%]
-      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)      ::   p_fr2    ! 2nd fraction of qsr penetration in ice (T-point)  [%]
-      CHARACTER(len=1), INTENT(in   )                  ::   cd_grid  ! ice grid ( C or B-grid)
+      REAL(wp), INTENT(in   ), DIMENSION(:,:,:)      ::   pst      ! ice surface temperature (>0, =rt0 over land) [Kelvin]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj)    ::   pui      ! ice surface velocity (i- and i- components      [m/s]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj)    ::   pvi      !    at I-point (B-grid) or U & V-point (C-grid)
+      REAL(wp), INTENT(in   ), DIMENSION(:,:,:)      ::   palb     ! ice albedo (clear sky) (alb_ice_cs)               [%]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_taui   ! i- & j-components of surface ice stress        [N/m2]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_tauj   !   at I-point (B-grid) or U & V-point (C-grid)
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_qns    ! non solar heat flux over ice (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_qsr    !     solar heat flux over ice (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_qla    ! latent    heat flux over ice (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_dqns   ! non solar heat sensistivity  (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(:,:,:)      ::   p_dqla   ! latent    heat sensistivity  (T-point)         [W/m2]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_tpr    ! total precipitation          (T-point)      [Kg/m2/s]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_spr    ! solid precipitation          (T-point)      [Kg/m2/s]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_fr1    ! 1sr fraction of qsr penetration in ice (T-point)  [%]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj)    ::   p_fr2    ! 2nd fraction of qsr penetration in ice (T-point)  [%]
+      CHARACTER(len=1), INTENT(in   )                ::   cd_grid  ! ice grid ( C or B-grid)
+      INTEGER, INTENT(in   )                         ::   pdim     ! number of ice categories
       !!
       INTEGER  ::   ji, jj, jl    ! dummy loop indices
@@ -380,11 +377,11 @@
       REAL(wp) ::             zwndi_t , zwndj_t                  ! relative wind components at T-point
       REAL(wp), DIMENSION(jpi,jpj) ::   z_wnds_t                 ! wind speed ( = | U10m - U_ice | ) at T-point
-      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_qlw                ! long wave heat flux over ice
-      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_qsb                ! sensible  heat flux over ice
-      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_dqlw               ! sensible  heat flux over ice
-      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z_dqsb               ! sensible  heat flux over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qlw                ! long wave heat flux over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_qsb                ! sensible  heat flux over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_dqlw               ! sensible  heat flux over ice
+      REAL(wp), DIMENSION(jpi,jpj,pdim) ::   z_dqsb               ! sensible  heat flux over ice
       !!---------------------------------------------------------------------
 
-      ijpl  = jpl                            ! number of ice categories
+      ijpl  = pdim                            ! number of ice categories
 
       ! local scalars ( place there for vector optimisation purposes)
Index: /trunk/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 1269)
+++ /trunk/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 1270)
@@ -145,5 +145,5 @@
                &                      qla_ice   , dqns_ice  , dqla_ice  ,               &
                &                      tprecip   , sprecip   ,                           &
-               &                      fr1_i0    , fr2_i0    , cl_grid  )
+               &                      fr1_i0    , fr2_i0    , cl_grid, jpl  )
             !         
          CASE( 4 )                                       ! CORE bulk formulation
@@ -152,5 +152,5 @@
                &                      qla_ice  , dqns_ice  , dqla_ice  ,               &
                &                      tprecip  , sprecip   ,                           &
-               &                      fr1_i0   , fr2_i0    , cl_grid  )
+               &                      fr1_i0   , fr2_i0    , cl_grid, jpl  )
          END SELECT
 
Index: /trunk/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 1269)
+++ /trunk/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 1270)
@@ -21,4 +21,5 @@
    USE lib_mpp
    USE ice_2
+   USE par_ice_2
    USE iceini_2
    USE ice_oce         ! ice variables
@@ -154,5 +155,5 @@
                &                      zqla_ice  , zdqns_ice  , zdqla_ice ,             &
                &                      tprecip   , sprecip    ,                         &
-               &                      fr1_i0    , fr2_i0     , cl_grid  )
+               &                      fr1_i0    , fr2_i0     , cl_grid, jpl  )
 
          CASE( 4 )           ! CORE bulk formulation
@@ -161,5 +162,5 @@
                &                      zqla_ice  , zdqns_ice  , zdqla_ice ,             &
                &                      tprecip   , sprecip    ,                         &
-               &                      fr1_i0    , fr2_i0     , cl_grid  )
+               &                      fr1_i0    , fr2_i0     , cl_grid, jpl  )
          CASE( 5 )           ! Coupled formulation : atmosphere-ice stress only (fluxes provided after ice dynamics)
             CALL sbc_cpl_ice_tau( utaui_ice , vtaui_ice )