Index: /trunk/CONFIG/GYRE/scripts/BB_make
===================================================================
--- /trunk/CONFIG/GYRE/scripts/BB_make	(revision 1275)
+++ /trunk/CONFIG/GYRE/scripts/BB_make	(revision 1276)
@@ -3774,4 +3774,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -3780,8 +3781,11 @@
 	daymod.F90 \
 	dom_oce.F90 \
-	in_out_manager.F90 \
-	iom.F90 \
-	oce.F90 \
-	phycst.F90 \
+	geo2ocean.F90 \
+	in_out_manager.F90 \
+	iom.F90 \
+	oce.F90 \
+	phycst.F90 \
+	$(AGRIF_LIB) \
+	KEY_CPP \
 	fldread.F90
 $(MODEL_LIB)(flo4rk.o) :	\
@@ -6368,4 +6372,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6386,4 +6391,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -6436,4 +6442,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6453,4 +6460,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -6575,4 +6583,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6592,4 +6601,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -6683,4 +6693,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6699,4 +6710,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7111,4 +7123,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7129,4 +7142,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7229,4 +7243,5 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(fldread.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7249,4 +7264,5 @@
 	dom_oce.F90 \
 	fldread.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
Index: /trunk/CONFIG/GYRE_LOBSTER/scripts/BB_make
===================================================================
--- /trunk/CONFIG/GYRE_LOBSTER/scripts/BB_make	(revision 1275)
+++ /trunk/CONFIG/GYRE_LOBSTER/scripts/BB_make	(revision 1276)
@@ -3906,4 +3906,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -3912,8 +3913,11 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
 	oce.F90 \
 	phycst.F90 \
+	$(AGRIF_LIB) \
+	KEY_CPP \
 	fldread.F90
 $(MODEL_LIB)(flo4rk.o) :	\
@@ -7595,4 +7599,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7613,4 +7618,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7663,4 +7669,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7680,4 +7687,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7802,4 +7810,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7819,4 +7828,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7910,4 +7920,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7926,4 +7937,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8338,4 +8350,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8356,4 +8369,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8456,4 +8470,5 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(fldread.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8476,4 +8491,5 @@
 	dom_oce.F90 \
 	fldread.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
Index: /trunk/CONFIG/ORCA2_LIM/scripts/BB_make
===================================================================
--- /trunk/CONFIG/ORCA2_LIM/scripts/BB_make	(revision 1275)
+++ /trunk/CONFIG/ORCA2_LIM/scripts/BB_make	(revision 1276)
@@ -4085,4 +4085,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -4091,8 +4092,11 @@
 	daymod.F90 \
 	dom_oce.F90 \
-	in_out_manager.F90 \
-	iom.F90 \
-	oce.F90 \
-	phycst.F90 \
+	geo2ocean.F90 \
+	in_out_manager.F90 \
+	iom.F90 \
+	oce.F90 \
+	phycst.F90 \
+	$(AGRIF_LIB) \
+	KEY_CPP \
 	fldread.F90
 $(MODEL_LIB)(flo4rk.o) :	\
@@ -6679,4 +6683,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6697,4 +6702,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -6747,4 +6753,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6764,4 +6771,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -6886,4 +6894,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -6903,4 +6912,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -6994,4 +7004,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7010,4 +7021,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7422,4 +7434,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7440,4 +7453,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7540,4 +7554,5 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(fldread.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7560,4 +7575,5 @@
 	dom_oce.F90 \
 	fldread.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
Index: /trunk/CONFIG/ORCA2_LIM_PISCES/scripts/BB_make
===================================================================
--- /trunk/CONFIG/ORCA2_LIM_PISCES/scripts/BB_make	(revision 1275)
+++ /trunk/CONFIG/ORCA2_LIM_PISCES/scripts/BB_make	(revision 1276)
@@ -4226,4 +4226,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -4232,8 +4233,11 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
 	oce.F90 \
 	phycst.F90 \
+	$(AGRIF_LIB) \
+	KEY_CPP \
 	fldread.F90
 $(MODEL_LIB)(flo4rk.o) :	\
@@ -7915,4 +7919,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7933,4 +7938,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7983,4 +7989,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8000,4 +8007,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8122,4 +8130,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8139,4 +8148,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8230,4 +8240,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8246,4 +8257,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8658,4 +8670,5 @@
 	$(MODEL_LIB)(daymod.o) \
 	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8676,4 +8689,5 @@
 	daymod.F90 \
 	dom_oce.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8776,4 +8790,5 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(fldread.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8796,4 +8811,5 @@
 	dom_oce.F90 \
 	fldread.F90 \
+	geo2ocean.F90 \
 	in_out_manager.F90 \
 	iom.F90 \