Index: /trunk/NEMO/TOP_SRC/LOBSTER/trclsm_lobster.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/LOBSTER/trclsm_lobster.F90	(revision 1282)
+++ /trunk/NEMO/TOP_SRC/LOBSTER/trclsm_lobster.F90	(revision 1283)
@@ -54,5 +54,5 @@
       TYPE(DIAG) , DIMENSION(jp_lobster_3d) :: lobdia3d
 #endif
-#if defined key_trc_diabio
+#if defined key_trc_diabio || defined key_trdmld_trc
       INTEGER :: js, jd
       ! definition of additional diagnostic as a structure
@@ -81,5 +81,5 @@
       NAMELIST/namlobdia/nwritedia, lobdia3d, lobdia2d     ! additional diagnostics
 #endif
-#if defined key_trc_diabio
+#if defined key_trc_diabio || defined key_trdmld_trc
       NAMELIST/namlobdbi/nwritebio, lobdiabio
 #endif
@@ -341,6 +341,5 @@
 #endif
 
-#if defined key_trc_diabio
-
+#if defined key_trc_diabio || defined key_trdmld_trc
       ! namlobdbi : bio diagnostics
       nwritebio = 10                     ! default values
Index: /trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1282)
+++ /trunk/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1283)
@@ -1338,4 +1338,8 @@
       nmoymltrdbio   = 0
       tmltrd_sum_bio     (:,:,:) = 0.e0     ;   tmltrd_csum_ln_bio (:,:,:) = 0.e0
+      DO jl = 1, jp_lobster_trd
+          ctrd_bio(jl,1) = ctrbil(jl)   ! long name
+          ctrd_bio(jl,2) = ctrbio(jl)   ! short name
+       ENDDO
 #endif
 
@@ -1458,29 +1462,8 @@
 
 #if defined key_lobster
-
-          ctrd_bio(1,:) = "NO3PHY"
-          ctrd_bio(2,:) = "NH4PHY"
-          ctrd_bio(3,:) = "PHYNH4"
-          ctrd_bio(4,:) = "PHYDOM"
-          ctrd_bio(5,:) = "PHYZOO"
-          ctrd_bio(6,:) = "PHYDET"
-          ctrd_bio(7,:) = "DETZOO"
-          ctrd_bio(8,:) = "DETSED"
-          ctrd_bio(9,:) = "ZOODET"
-          ctrd_bio(10,:) = "ZOOBOD"
-          ctrd_bio(11,:) = "ZOONH4"
-          ctrd_bio(12,:) = "ZOODOM"
-          ctrd_bio(13,:) = "NH4NO3"
-          ctrd_bio(14,:) = "DOMNH4"
-          ctrd_bio(15,:) = "DETNH4"
-          ctrd_bio(16,:) = "DETDOM"
-          ctrd_bio(17,:) = "SEDNO3"
-
-
           !-- Create a NetCDF file and enter the define mode
           CALL dia_nam( clhstnam, ntrd_trc, 'trdbio' )
           CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,                                            &
              &             1, jpi, 1, jpj, 0, zjulian, rdt, nh_tb, nidtrdbio, domain_id=nidom )
-
 #endif
 
@@ -1528,5 +1511,5 @@
 
 #if defined key_lobster
-      DO jl = 1, jpdiabio
+      DO jl = 1, jp_lobster_trd
          CALL histdef(nidtrdbio, TRIM("ML_"//ctrd_bio(jl,2)), TRIM(clmxl//" ML_"//ctrd_bio(jl,1))   ,            &
              &    cltrcu, jpi, jpj, nh_tb, 1  , 1, 1  , -99 , 32, clop, zsto, zout ) ! IOIPSL: time mean
Index: /trunk/NEMO/TOP_SRC/TRP/trdmld_trc_rst.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/TRP/trdmld_trc_rst.F90	(revision 1282)
+++ /trunk/NEMO/TOP_SRC/TRP/trdmld_trc_rst.F90	(revision 1283)
@@ -51,5 +51,5 @@
            WRITE(clkt,'(i8.8)') nitrst
          ENDIF
-         clname = TRIM(cexper)//"_"//TRIM(ADJUSTL(clkt))//"_restart_mld_trc"
+         clname = TRIM(cexper)//"_"//TRIM(ADJUSTL(clkt))//"_"//TRIM(cn_trdrst_trc_out)
          IF(lwp) WRITE(numout,*) '             open ocean restart_mld_trc NetCDF  '//clname
          CALL iom_open( clname, nummldw_trc, ldwrt = .TRUE., kiolib = jprstlib )
@@ -140,5 +140,5 @@
       ENDIF
       
-      CALL iom_open( 'restart_mld_trc', inum, kiolib = jprstlib ) 
+      CALL iom_open( cn_trdrst_trc_in, inum, kiolib = jprstlib ) 
       
       IF( ln_trdmld_trc_instant ) THEN 
Index: /trunk/NEMO/TOP_SRC/trc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/trc.F90	(revision 1282)
+++ /trunk/NEMO/TOP_SRC/trc.F90	(revision 1283)
@@ -57,6 +57,6 @@
    INTEGER , PUBLIC  ::  nutrst     !: logical unit for restart FILE for passive tracers
    INTEGER , PUBLIC  ::  nrsttr     !: control of the time step ( 0 or 1 ) for pass. tr.
-   CHARACTER(len=32) ::  cn_trcrst_in  !: suffix of pass. tracer restart name (input)
-   CHARACTER(len=32) ::  cn_trcrst_out !: suffix of pass. tracer restart name (output)
+   CHARACTER(len=50) ::  cn_trcrst_in  !: suffix of pass. tracer restart name (input)
+   CHARACTER(len=50) ::  cn_trcrst_out !: suffix of pass. tracer restart name (output)
    
    !! information for outputs
@@ -74,27 +74,20 @@
    CHARACTER(len=80), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3l   !: 3d output field long name
 
-   
    REAL(wp), PUBLIC, DIMENSION (jpi,jpj,    jpdia2d) ::   trc2d   !:  additional 2d outputs  
    REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jpdia3d) ::   trc3d   !:  additional 3d outputs  
    
-   
-   !! netcdf files and index common
-   !! --------------------------------------------------
    INTEGER , PUBLIC ::   nwritedia     !: frequency of additional arrays outputs(namelist)
 # endif
 
-# if defined key_trc_diabio
-
-   !! Biological trends
-   !! -----------------
+#if defined key_trc_diabio || defined key_trdmld_trc
    CHARACTER(len=8),  DIMENSION(jpdiabio) ::   ctrbio   !: biological trends name      (NAMELIST)
    CHARACTER(len=20), DIMENSION(jpdiabio) ::   ctrbiu   !: biological trends unit      (NAMELIST)
    CHARACTER(len=80), DIMENSION(jpdiabio) ::   ctrbil   !: biological trends long name (NAMELIST)
+   INTEGER ::   nwritebio   !: time step frequency for biological outputs (NAMELIST)
+#endif
+# if defined key_trc_diabio
+   !! Biological trends
+   !! -----------------
    REAL(wp), DIMENSION(jpi,jpj,jpk,jpdiabio) :: trbio   !: biological trends
-
-   !! Netcdf output parameters
-   !! ------------------------
-   INTEGER ::   nwritebio   !: time step frequency for biological outputs (NAMELIST)
-
 # endif
 